#include "commun.h"

//MULTIBOOT

int ntBalle, ntBille, ntBlocs;
int score, vies, invincible;

#define MAX_BALLES 1
#define MAX_BILLES 20
#define MAX_BLOCS 32

typedef struct      {
    int x,y;
    int l, h;
    int vx, vy;
    int noshock;
    int angle;
    int supervitesse;
} BILLE;

typedef struct      {
    int x, y;
    int l, h;
    int accoup;
} BALLE;

typedef struct    {
    int x, y;
    int l, h;
} BLOC;

void InitBille(BILLE *b)        {
    b->x=50<<8;
    b->y=20<<8;
    b->vx=0<<8;
    b->vy=1<<8;
    b->l=11<<8;
    b->h=11<<8;
    b->noshock=0;
    b->angle=90;
    b->supervitesse=0;
}

void InitBalle(BALLE *b)        {
    b->x=40<<8;
//    b->y=128<<8;
    b->y=144<<8;
    b->l=32<<8;
    b->h=32<<8;
}

const unsigned long balle_mask[]=      {
	0x3c000,
	0x3ffc00,
	0xffff00,
	0x1ffff80,
	0x7ffffe0,
	0xffffff0,
	0xffffff0,
	0x1ffffff8,
	0x3ffffffc,
	0x3ffffffc,
	0x7ffffffe,
	0x7ffffffe,
	0x7ffffffe,
	0xffffffff,
	0xffffffff,
	0xffffffff,
	0xffffffff,
	0xffffffff,
	0xffffffff,
	0x7ffffffe,
	0x7ffffffe,
	0x7ffffffe,
	0x3ffffffc,
	0x3ffffffc,
	0x1ffffff8,
	0xffffff0,
	0xffffff0,
	0x7ffffe0,
	0x1ffff80,
	0xffff00,
	0x3ffc00,
	0x3c000,
};

const unsigned long bille_mask[]=      {
	0x70,
	0x1fc,
	0x3fe,
	0x3fe,
	0x7ff,
	0x7ff,
	0x7ff,
	0x3fe,
	0x3fe,
	0x1fc,
	0x70,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
	0x0,
};

#define EXT_XCHG(x,y)      {i=x;x=y;y=i;}
// checks for collision between 2 sprites of width 16
// returns 1 if a collision is detected
short TestCollide32(short x0,short y0,short x1,short y1,
                    short height,unsigned long* data0, unsigned long* data1)
{
    int dx,dy,i,j,change;

    // sprite 0 is left of sprite 1 ...
    if (x0<x1) {
        dx = x1-x0;
        change=0;
    }
    else {
        // if sprite 0 is right of sprite 1 just exchange
        // all necessary variables so we can still assume
        // sprite 0 is left of sprite 1 ...
        dx = x0-x1;
        EXT_XCHG(data0,data1);
        EXT_XCHG(y0,y1);
        change=1;
    }

    if (dx>=32) return 0; // cannot overlap in this case (x difference too large)

    if (y0<y1) {
        dy = y1-y0;
        data1+=dy;
        if (change)	j=dy;
        else				j=0;
    }
    else {
        dy = y0-y1;
        data0+=dy;
        if (change)	j=0;
        else				j=dy;
    }
    if (dy>=32)
      return 0;

    for (i=dy;i<height;i++,data0++,data1++) {
   			j++;
        // Let's shift the data of sprite 0 to the left and AND it with
        // the data of sprite 1. If this results in at least one bit set,
        // we have a collision
        // Note: On utilise ici une version inverse du masque paysage de chaque "tile"
        if (*data1 && *data0)    {
//            Debug("%x %x",(int)((u64)*data1),(int)(((u64)*data0) << dx));
        }
//          Debug("%x %x %i  ",(int)*data0,(int)*data1,dx);
        if (((u64)*data1) & (((u64)*data0) << dx))	{
/* 						if (colPtr==0)						//Aucune collision jusqu' maintenant?
							collisions[colPtr++]=j/2;	//On stocke le rsultat
						else if (colPtr==1 && ((collisions[0]!=8 && j/2==8) || (collisions[0]==8 && j/2!=8)))
							collisions[colPtr++]=j/2;		//Une condition dj existante. La nouvelle ne sera stocke  la suite de l'ancienne que si elle ne dsigne pas la mme collision
						if (colPtr>=2)
							return 0;*/
						return j;
				}
   }
    // if we come here we have found no collision!
    return 0;
}

int DetecteCollisionBalle(BALLE *ba, BILLE *bi)        {
   if (TestCollide32(ba->x>>8,ba->y>>8,bi->x>>8,bi->y>>8,32,bille_mask,balle_mask))
      return 1;
   else
      return 0;
}

void GereBalle(BALLE *b)     {
    int y;
    if (REG_TOUCHES&TOUCHE_HAUT)
        b->y-=1<<8;
    if (REG_TOUCHES&TOUCHE_BAS)
        b->y+=1<<8;
    if (REG_TOUCHES&TOUCHE_GAUCHE && b->x>0)
        b->x-=3<<8;
    if (REG_TOUCHES&TOUCHE_DROITE && b->x+b->l<240<<8)
        b->x+=3<<8;
    if (REG_TOUCHES&TOUCHE_A && b->accoup==0)
        b->accoup=1;
    while(REG_TOUCHES&TOUCHE_START);
    if (b->x<0)        b->x=0;
    if (b->x+b->l>=240<<8)        b->x=(240<<8)-b->l;
    if (b->y<0)        b->y=0;
    if (b->y>150<<8)   b->y=(150<<8);
    if (b->accoup>0 && b->accoup<=4)
      b->y-=1<<8;
    else if (b->accoup>4 && b->accoup<=8)
      b->y+=1<<8;
    y=b->y>>8;
    CreeObjetStandard(b->x>>8, y, ntBalle, 0, TAILLE_32x32);
    if (b->accoup)      {
      if (b->accoup<32)
         PaletteObj[0x02]=RGB(31-b->accoup,31-b->accoup,31);
      b->accoup++;
    }
    if (b->accoup>=90)     {
         PaletteObj[0x02]=RGB(31,31,31);
         b->accoup=0;
    }
}

#include <math.h>

void Rebondit(BALLE *ba, BILLE *bi)     {
    int val, max, bas, coreangle;
    double angle, vitesse, curSpeed;
    val=bi->x+bi->l-ba->x;
    max=bi->l+ba->l;

    //Touch le bas de la boule? (ok)
    if (bi->y+bi->h/2>ba->y+ba->h/2)
      bas=1;
    else
      bas=0;
   //Angle ok
    if (bas)
       angle=(180+((180*val)/max));
    else
       angle=(180-((180*val)/max));
    int valll=(int)(256*(double)bi->vx/((double)bi->vy));
//    Debug("%i",(int)(atan(valll/256.0)*180/3.1416));
//    Debug("%i %i %i %i",(int)angle,bi->angle,valll,(int)(atan(valll/256.0)*180/3.1416));
//    bi->angle=90-angle;
//    Debug("%i %i %i",(int)angle,val,max);
    angle=(angle-(int)(atan(valll/256.0)*180/3.1416));
    curSpeed=sqrt(bi->vx*bi->vx+bi->vy*bi->vy)/256.0;
    //Ok c'est pas vraiment physique tout a, mais qu'est-ce que vous voulez... :)
    if (bas)      {
       if (angle<180)         angle=180;
       if (angle>360)         angle=360;
    }
    else {
       if (angle>180)         angle=180;
       if (angle<0)          angle=0;
    }
//    Debug("%i",(int)angle);
    //Ajoute le dernier angle au score
    if (bas)
      coreangle=270;
    else
      coreangle=90;

    if (bi->supervitesse)
       score+=abs(coreangle-angle)/15+1;
    else
       score+=abs(coreangle-angle)/10+2;

    bi->angle=angle;
    angle=angle*3.1416/180.0;

    if (ba->accoup>0 && ba->accoup<=8)    {
       vitesse=5.00;
       bi->supervitesse=1;
    }
    else    {
       vitesse=3.50;
       bi->supervitesse=0;
    }
    bi->vx=(int)(256.0*cos(angle)*vitesse);
    bi->vy=(int)(256.0*sin(angle)*-vitesse);
/*    bi->vx=(int)(256.0*cos(angle)*curSpeed);
    bi->vy=(int)(256.0*sin(angle)*-curSpeed);*/
//    Debug("%i",bi->vy);
    bi->noshock=10;
}

void GereBille(BALLE *ba, BILLE *bi)        {
    bi->x += bi->vx;
    bi->y += bi->vy;
    
    bi->vy += 1<<4;
    printf_xy(0,0,"Score:% 6i",score);
    printf_xy(0,1,"Vies:    %i",vies);
//    printf_xy(0,3,"%i %i  ",bi->vx,bi->vy);

    if (bi->noshock<=0 && DetecteCollisionBalle(ba,bi))        {
        Rebondit(ba,bi);
    }
    if (bi->noshock>0)
        bi->noshock--;
    if (bi->x<0<<8)
        bi->vx=-bi->vx, bi->x=0;
    if (bi->y<0<<8)
        bi->vy=-bi->vy, bi->y=0;
    if (bi->x+bi->l>239<<8)
        bi->vx=-bi->vx, bi->x=(239<<8)-bi->l;
    if (bi->y+bi->h>159<<8)      {
        bi->vy=-bi->vy;
         if (invincible==0)
            vies--, invincible=60;
     }

    if (invincible%2==0)
       CreeObjetStandard(bi->x>>8, bi->y>>8, ntBille, 0, TAILLE_16x16);
}

const unsigned char anglesRebonditBloc[44]=    {
   170,160,140,130,120,115,110,105,
   100,95,92,90,90,90,90,90,
   //Supplment
   90,90,90,90,90,90,90,90,90,90,90,
   //Fin supplment
   90,90,90,90,90,88,85,80,
   75,70,65,60,50,40,20,10,
   //Pour viter les dbordements
   10
};

void RebonditBloc(BILLE *bi, BLOC *bo)     {
    int val, bas, coreangle;
    double angle;
    const double vitesse=1.50, curSpeed;
    val=bi->x+bi->l-bo->x;
//    max=bi->l+bo->l;

//    Debug("%i %i %i %i",bo->x>>8,bo->l>>8,bi->x>>8,bi->l>>8);
//    Debug("# %i",val>>8);
    //Touch le bas de la boule? (ok)
    if (bi->y+bi->h/2>bo->y+bo->h/2)
      bas=1;
    else
      bas=0;
   //Angle ok
    if (bas)
       angle=360-anglesRebonditBloc[val>>8];
    else
       angle=anglesRebonditBloc[val>>8];
//    Debug("%i (%i)",(int)angle,val>>8);
    int valll=(int)(256*(double)bi->vx/((double)bi->vy));
//    Debug("%i",(int)(atan(valll/256.0)*180/3.1416));
//    Debug("%i %i %i %i",(int)angle,bi->angle,valll,(int)(atan(valll/256.0)*180/3.1416));
//    bi->angle=90-angle;
//    Debug("%i %i %i",(int)angle,val,max);
    angle=(angle-(int)(atan(valll/256.0)*180/3.1416));
    curSpeed=sqrt(bi->vx*bi->vx+bi->vy*bi->vy)/256.0;
    //Ok c'est pas vraiment physique tout a, mais qu'est-ce que vous voulez... :)
    if (bas)      {
       if (angle<190)         angle=190;
       if (angle>350)         angle=350;
    }
    else {
       if (angle>170)         angle=170;
       if (angle<10)          angle=10;
    }
//    Debug("%i",(int)angle);
    //Ajoute le dernier angle au score
    if (bas)
      coreangle=270;
    else
      coreangle=90;

    if (bi->supervitesse)
       score+=abs(coreangle-angle)/15+1;
    else
       score+=abs(coreangle-angle)/10+2;

    bi->angle=angle;
    angle=angle*3.1416/180.0;

    bi->vx=(int)(256.0*cos(angle)*curSpeed);
    bi->vy=(int)(256.0*sin(angle)*-curSpeed);
//    Debug("%i",bi->vy);
    bi->noshock=10;
}

int DetecteCollisionBloc(BILLE *bi, BLOC *bo)     {
    if (bi->x+bi->l>=bo->x && bi->x<=bo->x+bo->l &&
        bi->y+bi->h>=bo->y && bi->y<=bo->y+bo->h)
            return 1;
    else
            return 0;
}

void GereBloc(BILLE *bi, BLOC *bo)     {
   if (DetecteCollisionBloc(bi,bo))    {
      RebonditBloc(bi,bo);
   }
   CreeObjetStandard(bo->x>>8, bo->y>>8, ntBlocs, 0, TAILLE_32x16);
}

int main(void)
{
    BALLE balle[MAX_BALLES];
    BILLE bille[MAX_BILLES];
    BLOC blocs[MAX_BLOCS];
    int i, nbBilles, nbBlocs;
    
    REG_DISPCNT = VIDEO_MODE0 | VIDEO_BG0_ENABLED | VIDEO_BG3_ENABLED | OBJ_ENABLED | 0x40;
    REG_BG3CNT = BG_TEXTE_256x256 | BG_16_PALETTES | BG_WRAP | 30<<8 | 0 | BG_CHARBLOCK_3;

    for (i=0;i<MAX_BALLES;i++)
        InitBalle(&balle[i]);
    for (i=0;i<MAX_BILLES;i++)
        InitBille(&bille[i]);

    Init();
    CopieDMA((void*)balle_palette,(void*)PaletteObj,16,DMA_16im);
    CopieDMA((void*)charset_tiles,(void*)CharBaseBlock(3),sizeof(charset_tiles)>>1,DMA_16im);

    ntBalle = AjTilesSprite((void*)balle_tiles,sizeof(balle_tiles));
    ntBille = AjTilesSprite((void*)bille_tiles,sizeof(bille_tiles));
    ntBlocs = AjTilesSprite((void*)blocs_tiles,sizeof(blocs_tiles));

    Palette[0xf1]=RGB(31,31,31);
    Palette[0]=RGB(24,0,0);                        //Fond rouge ptant
    PaletteObj[0x02]=RGB(31,31,31);
    PaletteObj[0x03]=RGB(31,31,31);
    memset(MonOAM,0,sizeof(MonOAM));
    
    score=0;
    vies=5;
    invincible=0;
    nbBilles=1;
    blocs[0].x=51<<8;
    blocs[0].y=70<<8;
    blocs[0].l=32<<8;
    blocs[0].h=16<<8;
    nbBlocs=1;

    while(TRUE)
    {
        ReinitSprites();
        GereBalle(&balle[0]);
        for (i=0;i<nbBilles;i++)
           GereBille(&balle[0],&bille[i]);
        for (i=0;i<nbBlocs;i++)
           GereBloc(&bille[0],&blocs[i]);
        if (REG_TOUCHES&TOUCHE_SELECT)      {
            while(REG_TOUCHES&TOUCHE_SELECT);
            nbBilles++;
        }
        if (invincible)    invincible--;
//        CreeObjetStandard(20, 60, ntBille, 0, TAILLE_16x16);
        AttendVSync();
        CopieDMA(MonOAM,pOAM,sizeof(MonOAM)>>2,DMA_32im);
    }

    return 0;
}


/* END OF FILE */
